import unittest, time, re
import os
import sys

from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import Select
from selenium.common.exceptions import NoSuchElementException
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities

import matplotlib
from datetime import datetime

T_DELAY = 1
LOG_FILE = "log"

class Collector():

	def set_gender(self, gender, driver):
		driver.get("https://www.google.com/settings/ads")
		driver.find_element_by_xpath(".//div[@class='Xd og c-O-va c-O-Wb']/div[@class='kc']/div/div[@class='Df Ec']").click()
		s = driver.find_elements_by_xpath(".//div[@class='fv Iz']/div[@class='aA Ko']/div/span[@class='a-y-ra']")
		if(gender == 'm'):
			s[0].click()
		elif(gender == 'f'):
			s[1].click()
		driver.find_element_by_xpath(".//div[@class='hf c-O-S']/div[@class='ag']/div[@class='c-ea-da a-b a-b-E Dz']").click()

	def get_gender(self, driver):
		driver.get("https://www.google.com/settings/ads")
		div = driver.find_element_by_xpath(".//div[@class='Xd og c-O-va c-O-Wb']/div[@class='kc']/div")
		inn = str(div.get_attribute('innerHTML'))
		return inn[0]
				
    
	def get_ad_pref(self, choice, driver):
		pref = []
		try:
			driver.get("https://www.google.com/settings/ads")
			if (choice == 1):
				driver.find_element_by_css_selector("div.Vu div.bd div.Sc div div div.cc").click()	#For search related preferences
			elif (choice == 2):
				driver.find_element_by_css_selector("div.Vu div.bd div.Qc div div div.cc").click()	#For website related preferences
			#print l
			idiv = driver.find_element_by_xpath(".//div[@class='ee c-N-F'][@style='']")
			ints = idiv.find_elements_by_xpath(".//div/div/div[@class='mu Vh Qh']")
			for interest in ints:
				div = interest.find_element_by_xpath(".//div[@class='fl']")
				pref.append(str(div.get_attribute('innerHTML')))
			#raw_input("Waiting...")
		except:
			pass
		return pref	

	def train_with_queries(self, qlist, visits, id, driver):
		self.log('training-start', id)
		global wpref1, wpref2, spref1, spref2
		for q in qlist:		# For all queries in the list, obtain search results on Google
# 			print ("\n\nQuery-- "+q)
# 			fop = open(PREF_FILE, "a")
# 			fop.write("\n\nQuery-- "+q+':\n')
# 			fop.close()
			try:
				driver.get("https://www.google.com/")
				driver.find_element_by_id("gbqfq").clear()
				driver.find_element_by_id("gbqfq").send_keys(q)
				driver.find_element_by_id("gbqfq").send_keys(Keys.RETURN)
			except:
				pass
			time.sleep(1)
			#driver.find_element_by_id("gbqfb").click()
			flag = 0
			for t in range(0,1):
				for y in range(1, visits): # How many search results to visit
					print y
					try:
						driver.find_element_by_css_selector("ol#rso li:nth-of-type("+str(y)+") div h3 a").click()
						time.sleep(3)
						print driver.current_url
# 						fop = open(PREF_FILE, "a")
# 						fop.write(driver.current_url+'\n')
# 						fop.write("WEBSITES\n")
# 						fop.close()
# 						wpref2 = self.get_ad_pref(WEBSITES)
# 						print wpref2
# 						self.compare_ad_prefs(wpref1, wpref2)
# 						wpref1 = wpref2
# 						driver.back()
						driver.back()
					except:
						pass
# 				fop = open(PREF_FILE, "a")
# 				fop.write("WEBSITES\n")
# 				fop.close()
# 				wpref2 = self.get_ad_pref(WEBSITES)
# 				print wpref2
# 				self.compare_ad_prefs(wpref1, wpref2)
# 				wpref1 = wpref2
# 				fop = open(PREF_FILE, "a")
# 				fop.write("SEARCH\n")
# 				fop.close()
# 				spref2 = self.get_ad_pref(SEARCH)
# 				print spref2
# 				self.compare_ad_prefs(spref1, spref2)
# 				spref1 = spref2
				if flag == 1:
					break
				flag = 1
				try:
					driver.get("https://www.google.com/")
					driver.find_element_by_id("gbqfq").clear()
					driver.find_element_by_id("gbqfq").send_keys(q)
					driver.find_element_by_id("gbqfq").send_keys(Keys.RETURN)
					driver.find_element_by_css_selector("a#pnnext.pn").click()
				except:
					raw_input("Google Waiting..")
			#self.collect_ads(reloads)
# 			fop = open(PREF_FILE, "a")
# 			fop.write("WEBSITES\n")
# 			fop.close()
# 			wpref2 = self.get_ad_pref(WEBSITES)
# 			print wpref2
# 			self.compare_ad_prefs(wpref1, wpref2)
# 			wpref1 = wpref2
 		self.log('training-end', id)
	
	
	def train_with_sites(self, FILE, driver, id):
		global wpref1, wpref2
		self.log('training-start', id)
		fo = open(FILE, "r")
		for line in fo:
			try:
				#print line.rstrip()
				time.sleep(T_DELAY)
				#self.log(self.get_gender(driver), id)
				driver.set_page_load_timeout(10)
				driver.get("http://"+line.rstrip())
				self.log(line.rstrip(), id)
 			except:
 				self.log("failed-"+line.rstrip(), id)
 				pass
 		self.log('training-end', id)
      
	def compare_ad_prefs(self, pref1, pref2):
		diff1 = list(set(pref2) - set(pref1))
		diff2 = list(set(pref1) - set(pref2))
		fop = open(PREF_FILE, "a")
		print("Added:")
		print diff1
		print("Removed:")
		print diff2
		fop.write("Added:\n")
		for d in diff1:
			fop.write(d+", ")
		fop.write("\nRemoved:\n")
		for d in diff2:
			fop.write(d+", ")
		fop.close()

    
	def log(self, msg, id):
		fo = open(LOG_FILE, "a")
		fo.write(str(datetime.now())+"||"+msg+"||"+str(id) + '\n')
		fo.close()   

	def wait_for_others(self, instances, id):
		if (instances == 1):
			return
		clear = False
		while(not clear):
			c = [0]*instances
			fo = open(LOG_FILE, "r")
			for line in fo:
				chunks = re.split("\|\|", line)
				if(chunks[0] == 'g'):
					continue
				tim = chunks[0]
				msg = chunks[1]
				id1 = chunks[2].rstrip()
				if(msg=='training-start'):
					c[int(id1)-1] += 1
				if(msg=='training-end'):
					c[int(id1)-1] -= 1
			fo.close()
			time.sleep(5)
# 			print str(id)
# 			print c
			clear = True
			for i in range(0, instances):
				if(c[i] == 0):
					clear = clear and True
				else:
					clear = False
		
	
	def collect_ads(self, reloads, delay, file, driver, id):
		rel = 0
		#last_check = matplotlib.dates.date2num(datetime.now())
		while (rel < reloads):	# number of reloads on sites to capture all ads
			time.sleep(delay)
   			try:
				for i in range(0,1):
					self.save_ads_ctribune(file, driver)
					#self.save_ads_toi(file, driver, id)
					#self.save_ads_fox(file, driver, id)
					#self.save_ads_bbc(file, driver)
					#self.save_ads_nyt(file, driver)
					#self.save_ads_guardian(file, driver)
					#self.save_ads_time(file, driver)
					self.log('reload', id)
					#self.wait_for_others()
 			except:
 				pass
#  			if(matplotlib.dates.date2num(datetime.now()) - last_check > INT/3.0):
# 				ad_int.purge_within_interval(INT)
# 				ad_int.display(2)
#  				#self.update_ad2_int()
			rel = rel + 1

	def save_ads_time(self, file, driver):
# 		global ad_int
		driver.set_page_load_timeout(10)
		driver.get("http://www.time.com/time/")
		time = str(datetime.now())
		els = driver.find_elements_by_css_selector("div.google-ad p")
		print len(els)
		for el in els:
			t = el.find_element_by_css_selector("a.ad-title").get_attribute('innerHTML')
			l = el.find_element_by_css_selector("a.ad-url").get_attribute('innerHTML')
			b = el.find_element_by_css_selector("span.ad-desc").get_attribute('innerHTML')
			f = (time+"||"+t+"||"+l+"||"+b).encode("utf8")
			fo = open(file, "a")
			fo.write(f + '\n')
			fo.close()
# 			a = anna.Ad({'Time':datetime.strptime(time, "%Y-%m-%d %H:%M:%S.%f"), 
# 					'Title':t, 'URL': l, 'Body': b, 'cat': ""})
# 			ad_int.add(a)
				

	def save_ads_guardian(self, file, driver):
# 		global ad_int
		driver.set_page_load_timeout(10)
		driver.get("http://www.theguardian.com/world/usa")
		time = str(datetime.now())
		els = driver.find_elements_by_css_selector("div#google-ads-container div ul li")
		print len(els)
		for el in els:
			ps = el.find_elements_by_css_selector("p")
			t = ps[0].find_element_by_css_selector("a").get_attribute('innerHTML')
			b = ps[1].get_attribute('innerHTML')
			l = ps[2].find_element_by_css_selector("a").get_attribute('innerHTML')
			f = (time+"||"+t+"||"+l+"||"+b).encode("utf8")
			fo = open(file, "a")
			fo.write(f + '\n')
			fo.close()
# 			a = anna.Ad({'Time':datetime.strptime(time, "%Y-%m-%d %H:%M:%S.%f"), 
# 					'Title':t, 'URL': l, 'Body': b, 'cat': ""})
# 			ad_int.add(a)
		
	
	def save_ads_nyt(self, file, driver):
# 		global ad_int
		driver.set_page_load_timeout(10)
		driver.get("http://www.nytimes.com/")
		time = str(datetime.now())
		els = driver.find_elements_by_css_selector("div#HPMiddle3 table tbody tr td table tbody tr td div")
		print len(els)
		for el in els:
			a = el.find_elements_by_css_selector("a")
			t = a[0].get_attribute('innerHTML').strip()
			l = a[1].get_attribute('innerHTML')
			text = el.get_attribute('innerHTML')
			text2 = re.split('<br>', text)
			b = text2[1].strip()
			f = (time+"||"+t+"||"+l+"||"+b).encode("utf8")
			fo = open(file, "a")
			fo.write(f + '\n')
			fo.close()
# 			a = anna.Ad({'Time':datetime.strptime(time, "%Y-%m-%d %H:%M:%S.%f"), 
# 					'Title':t, 'URL': l, 'Body': b, 'cat': ""})
# 			ad_int.add(a)
		

	def save_ads_bbc(self, file, driver):
# 		global ad_int
		driver.set_page_load_timeout(10)
		driver.get("http://www.bbc.com/news/")
		time = str(datetime.now())
		els = driver.find_elements_by_css_selector("div#bbccom_adsense_mpu div ul li")
		print len(els)
		for el in els:
			t = el.find_element_by_css_selector("h4 a").get_attribute('innerHTML')
			ps = el.find_elements_by_css_selector("p")
			b = ps[0].get_attribute('innerHTML')
			l = ps[1].find_element_by_css_selector("a").get_attribute('innerHTML')
			f = (time+"||"+t+"||"+l+"||"+b).encode("utf8")
			fo = open(file, "a")
			fo.write(f + '\n')
			fo.close()
# 			a = anna.Ad({'Time':datetime.strptime(time, "%Y-%m-%d %H:%M:%S.%f"), 
# 					'Title':t, 'URL': l, 'Body': b, 'cat': ""})
# 			ad_int.add(a)
		
	
	def save_ads_fox(self, file, driver, id):
		driver.set_page_load_timeout(60)
		driver.get("http://www.foxnews.com/us/index.html")
		time = str(datetime.now())
		frame1 = driver.find_element_by_xpath(".//iframe[@id='aswift_0']")
		driver.switch_to_frame(frame1)
		frame2 = driver.find_element_by_xpath(".//iframe[@id='google_ads_frame1']")
		driver.switch_to_frame(frame2)
		lis = driver.find_elements_by_css_selector("div#ads ul li")
		print len(lis)
		for li in lis:
			t = li.find_element_by_css_selector("td.rh-titlec div a span").get_attribute('innerHTML')
			l = li.find_element_by_css_selector("td.rh-urlc div div a span").get_attribute('innerHTML')
			b = li.find_element_by_css_selector("td.rh-bodyc div span").get_attribute('innerHTML')
			f = (str(id)+"||"+time+"||"+t+"||"+l+"||"+b).encode("utf8")
			fo = open(file, "a")
			fo.write(f + '\n')
			fo.close()
		driver.switch_to_default_content()
		driver.switch_to_default_content()
						


	def save_ads_toi(self, file, driver, id):
		driver.set_page_load_timeout(60)
		driver.get("http://timesofindia.indiatimes.com/international-home")
		frames = driver.find_elements_by_xpath(".//iframe[@src='http://timesofindia.indiatimes.com/configspace/ads/TOI_INTL_home_right.html']")
		driver.switch_to_frame(frames[0])
		ads = driver.find_elements_by_xpath(".//tbody/tr/td/table")
		print(len(ads))
		time = str(datetime.now())
		for ad in ads:
			aa = ad.find_elements_by_xpath(".//tbody/tr/td/a")
			#print(aa[0].get_attribute('innerHTML'))
			#print(aa[1].get_attribute('innerHTML'))
			bb = ad.find_elements_by_xpath(".//tbody/tr/td/span")
			#print(bb[0].get_attribute('innerHTML'))
			t = (str(id)+"||"+time+"||"+aa[0].get_attribute('innerHTML')+ "||" + aa[1].get_attribute('innerHTML')+ "||" + bb[0].get_attribute('innerHTML')).encode("utf8")
			#print t
			fo = open(file, "a")
			fo.write(t + '\n')
			fo.close()
		driver.switch_to_default_content()
		frames = driver.find_elements_by_xpath(".//iframe[@id='adhomepage']")
		driver.switch_to_frame(frames[0])
		ads = driver.find_elements_by_xpath(".//tbody/tr/td/table")
		print(len(ads))
		time = str(datetime.now())
		for ad in ads:
			aa = ad.find_elements_by_xpath(".//tbody/tr/td/a")
			#print(aa[0].get_attribute('innerHTML'))
			#print(aa[1].get_attribute('innerHTML'))
			bb = ad.find_elements_by_xpath(".//tbody/tr/td/span")
			#print(bb[0].get_attribute('innerHTML'))
			t = (str(id)+"||"+time+"||"+aa[0].get_attribute('innerHTML')+ "||" + aa[1].get_attribute('innerHTML')+ "||" + bb[0].get_attribute('innerHTML')).encode("utf8")
			#print t
			fo = open(file, "a")
			fo.write(t + '\n')
			fo.close()
		driver.switch_to_default_content()
		frames = driver.find_elements_by_xpath(".//iframe[@src='http://timesofindia.indiatimes.com/configspace/ads/TOI_INTL_home_bottom.html']")
		driver.switch_to_frame(frames[0])
		ads = driver.find_elements_by_xpath(".//tbody/tr/td/table")
		print(len(ads))
		time = str(datetime.now())
		for ad in ads:
			aa = ad.find_elements_by_xpath(".//tbody/tr/td/a")
			#print(aa[0].get_attribute('innerHTML'))
			#print(aa[1].get_attribute('innerHTML'))
			bb = ad.find_elements_by_xpath(".//tbody/tr/td/span")
			#print(bb[0].get_attribute('innerHTML'))
			t = (str(id)+"||"+time+"||"+aa[0].get_attribute('innerHTML')+ "||" + aa[1].get_attribute('innerHTML')+ "||" + bb[0].get_attribute('innerHTML')).encode("utf8")
			#print t
			fo = open(file, "a")
			fo.write(t + '\n')
			fo.close()
		driver.switch_to_default_content()
	
	def save_ads_ctribune(self, file, driver):
		driver.set_page_load_timeout(10)
		driver.get("http://www.chicagotribune.com/news/local/breaking/")
		board = driver.find_element_by_css_selector("div.googleAd iframe")
		driver.switch_to_frame(board)
		ads = driver.find_elements_by_xpath(".//div[@class='text-ad']")
		print len(ads)
		time = str(datetime.now())
		for ad in ads:
			a = ad.find_elements_by_xpath(".//a")
			text = ad.get_attribute('innerHTML')
			text2 = re.split('<br>', text)
			t = (time+"||"+a[0].get_attribute('innerHTML')+ "||" + a[1].get_attribute('innerHTML')+ "||" + text2[1]).encode("utf8")
			fo = open(file, "a")
			fo.write(t + '\n')
			fo.close()
		driver.switch_to_default_content()
